#ifndef MBOXSTORAGE_H

#define MBOXSTORAGE_H

#ifdef __cplusplus
extern "C" {
#endif

#include "mailstorage.h"

/* mbox storage */

/*
  mbox_mail_storage is the state data specific to the mbox storage.

  - pathname is the filename that contains the mailbox.
  
  - cached if this value is != 0, a persistant cache will be
      stored on local system.
  
  - cache_directory is the location of the cache.

  - flags_directory is the location of the flags.
*/

struct mbox_mail_storage {
  char * pathname;
  
  int cached;
  char * cache_directory;
  char * flags_directory;
};

/*
  mbox_mail_storage_init is the constructor for a mbox storage.

  @param storage this is the storage to initialize.
  
  @param pathname is the filename that contains the mailbox.
  
  @param cached if this value is != 0, a persistant cache will be
    stored on local system.

  @param cache_directory is the location of the cache

  @param flags_directory is the location of the flags
*/

int mbox_mail_storage_init(struct mail_storage * storage,
    char * pathname, int cached,
    char * cache_directory, char * flags_directory);

#ifdef __cplusplus
}
#endif

#endif
