#ifndef MHSTORAGE_H

#define MHSTORAGE_H

#ifdef __cplusplus
extern "C" {
#endif

#include "mailstorage.h"

/* mh storage */

/*
  mh_mail_storage is the state data specific to the MH storage.

  - pathname is the filename the root path of the MH storage.
  
  - cached if this value is != 0, a persistant cache will be
      stored on local system.
  
  - cache_directory is the location of the cache.

  - flags_directory is the location of the flags.
*/

struct mh_mail_storage {
  char * pathname;
  
  int cached;
  char * cache_directory;
  char * flags_directory;
};

/*
  mh_mail_storage_init is the constructor for a MH storage

  @param pathname is the filename the root path of the MH storage.
  
  @param cached if this value is != 0, a persistant cache will be
      stored on local system.
  
  @param cache_directory is the location of the cache.

  @param flags_directory is the location of the flags.
*/

int mh_mail_storage_init(struct mail_storage * storage,
    char * pathname, int cached,
    char * cache_directory, char * flags_directory);

#ifdef __cplusplus
}
#endif

#endif
